//
// CTCSS Apllication
//
// The program is the application to generate CTCSS tones using a Arduino Nano.
//
// Copyright: 2016 PE1CID
// Version:
// 1.0 06-01-2016 Initial version based on T813 Tone
//

#include "Arduino.h"
#include <Bounce2.h>
#include <CtcssToneId.h>
#include <CtcssTone.h>
#include <CtcssSwitchesDec.h>

void setup()
{
  uint8_t switch_val = 0;

  // initialize serial communication at 115200 bits per second:
  Serial.begin(115200);

  // Initialise the CTCSS tone generation
  CtcssTone.init();
  Serial.println("Tone init.");
  
  // inititalize the switches
  CtcssSwitchesDec.init();
  Serial.println("Switches init.");
  
  // set the start tone
  switch_val = CtcssSwitchesDec.get_switches();
  if ( switch_val < TONE_MAX_TONES )
  {
    if ( switch_val > 0 )
    {
      CtcssTone.tone_on( (Tone_Id) switch_val );
      Serial.print("Tone on: ");
      Serial.print(switch_val);
      Serial.println(".");
    }
    else
    {
      CtcssTone.tone_off();
      Serial.println("Tone off.");
    }
  }
}

void loop()
{
  uint8_t switch_val = 0;

  // Check if a button is pressed and handle buttons
  if ( CtcssSwitchesDec.handle_switches(&switch_val) )
  {
    // New switch value
    if ( switch_val < TONE_MAX_TONES )
    {
      if ( switch_val > 0 )
      {
        CtcssTone.tone_on( (Tone_Id) switch_val );
        Serial.print("Tone on: ");
        Serial.print(switch_val);
        Serial.println(".");
      }
      else
      {
        CtcssTone.tone_off();
        Serial.println("Tone off.");
      }
    }
  }
}
