/*
 * Functions to control of the internal EEPROM.
 *
 * Copyright: 2016 PE1CID
 * Version:
 * 1.0 16-04-2016 Initial version for Arduino
 */

/* Include files */
#include <inttypes.h>
#include <EEPROM.h>
#include "CtcssEeprom.h"

/* Definitions */

#define START_TONE_ADDRESS       (0x0000)
#define START_TONE_SIZE          (0x01)

// Constructors ////////////////////////////////////////////////////////////////

CtcssEepromClass::CtcssEepromClass()
{
}

// Private Methods //////////////////////////////////////////////////////////////

/*
 * set_start_tone
 * Function to set the start tone in the EEPROM.
 * in: tone
 * out: none
 * return: none
 */
void CtcssEepromClass::set_start_tone ( uint8_t tone )
{
  if ( EEPROM.read( START_TONE_ADDRESS ) != tone )
  {
    EEPROM.write( START_TONE_ADDRESS, tone );
  }
}

/*
 * get_start_tone
 * Function to get the start tone from the EEPROM.
 * in: none
 * out: none
 * return: tone
 */
uint8_t CtcssEepromClass::get_start_tone ( void )
{
  return EEPROM.read( START_TONE_ADDRESS );
}

// Preinstantiate Objects //////////////////////////////////////////////////////

CtcssEepromClass CtcssEeprom = CtcssEepromClass();

/* End of file CtcssEeprom.cpp */
